// WLClient.h : WLCLIENT AvP[ṼC wb_[ t@CłB
//

#if !defined(AFX_WLCLIENT_H__3450EB34_EFCD_45A6_BF9E_B0B654630BA6__INCLUDED_)
#define AFX_WLCLIENT_H__3450EB34_EFCD_45A6_BF9E_B0B654630BA6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// C V{

#include "WLClient.h"
#include "Client.h"
#include "WLDialog.h"
#include "Wave.h"

#define	WM_SOCKETEVENT	WM_USER+1
#define	WM_WAVE			WM_USER+2
/////////////////////////////////////////////////////////////////////////////
#define	RTIMEOUT	3000
#define	WTIMEOUT	3000
#define	STIMEOUT	3000
#define	WTIMERINTERVAL 3000
#define	clBack		RGB(192,192,192)
/////////////////////////////////////////////////////////////////////////////
// CWLClientApp
class CWLClientApp : public CWinApp
{
private:
	int			m_TcpRetryTime;
	CString		m_ServerName;
	int			m_PortTCP;
	CTcpFifo	m_TcpFifo;

	CMD_OPEN	m_InOpen;
	CMD_OPEN	m_OutOpen;
	CFifo		m_InFifo;
	RET_COUNTER	m_Counter;

	CWLDialog	*m_pDialog;
	CClient		*m_pSocket;
	COLORREF	m_clBack;

	int			m_swTimer;
	BOOL		m_mmptt;
	BOOL		m_swptt;
	WAVEFORMATEX	m_WFX;
	CWave		m_Wave;
private:
	void SetEXT(LPSTR t, LPCSTR pKey);
	BOOL CreateSocket(LPCSTR pName, UINT port);
	void DeleteSocket(void);
	BOOL IsConnected(void){return m_pSocket != NULL;}

	BOOL SendBuf(LPVOID p, int n);
	BOOL SendServer(int cmd, LPVOID p, UINT len);
	BOOL WaitOutReady(void);

	void InitWFX(const CMD_OPEN *pOpen);
	void CloseSwPTT(void);

public:
	void ReqConnect(void);
	void ReqDisconnect(void);
	void DispStatus(void);
	void OnTimer(void);
	void OnReceive(int nErrorCode);
	void SetSwPTT(LONG tx);
	void OpenMonitor(void);

public:
	void ProcessMessages(void);
	void SetPTT(LONG tx);
	LONG GetTimeout(void);

	BOOL InOpen(DWORD sampfreq, LONG size);
	void InClose(void);
	BOOL InRead(SHORT *buf);
	LONG GetInExist(void);
	BOOL IsInCritical(void);
	BOOL OutOpen(DWORD sampfreq, DWORD size);
	void OutAbort(void);
	void OutFlush(void);
	BOOL OutWrite(SHORT *buf);
	BOOL IsOutCritical(void);
	BOOL IsOutFull(void);
	LONG GetOutRemaining(void);
	LONG GetOutCounter(void);
	void SetOutCounter(LONG count);

public:
	CWLClientApp();
	inline COLORREF GetBackColor(void){return m_clBack;};
// I[o[Ch
	//{{AFX_VIRTUAL(CWLClientApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CWLClientApp)
	//}}AFX_MSG
	afx_msg LRESULT OnSocketEvent(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWaveEvent(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

inline COLORREF GetBackColor(void){ return ((CWLClientApp *)AfxGetApp())->GetBackColor();};
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_WLCLIENT_H__3450EB34_EFCD_45A6_BF9E_B0B654630BA6__INCLUDED_)
